"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const table = (bool, number, string, array, object) => ({
    [Boolean.toString()]: bool,
    [Number.toString()]: number,
    [String.toString()]: string,
    [Array.toString()]: array,
    [Object.toString()]: object,
});
const operations = table((value) => value, (value) => value, (value) => value, (value) => useClassName(...value), (value) => Object.keys(value).filter(key => useClassName(value[key])));
const type = (value) => (value.constructor.toString());
const pipe = (...fns) => (...args) => fns.reduce((acc, next) => next(acc), args);
const filter = (values) => values.filter(Boolean);
const map = (values) => values.map(value => (operations[type(value)] || (() => value))(value));
const flatten = (values) => (values.reduce((acc, val) => Array.isArray(val)
    ? acc.concat(flatten(val))
    : acc.concat(val), []));
const join = (values) => values.join(' ');
const trim = (values) => values.trim();
const useClassName = pipe(filter, map, flatten, join, trim);
exports.default = useClassName;
